
    //////////////////////////////////////////////
   //       YouTube Subscriber Counter         //
  //           Lilygo T5 4.7"     v1.00       //     
 //                                          //
//           http://www.educ8s.tv           //
/////////////////////////////////////////////

#include <Arduino.h>
#include "epd_driver.h" //https://github.com/Xinyuan-LilyGO/LilyGo-EPD47
#include <ArduinoJson.h>  //https://github.com/bblanchon/ArduinoJson
#include "YoutubeApi.h"  //https://github.com/witnessmenow/arduino-youtube-api
#include "youtube.h"
#include "font.h"
#include <WiFi.h>
#include <WiFiClientSecure.h>

//------- Replace the following! ------
const char ssid[] = "ssid";       // your network SSID (name)
const char password[] = "password";  // your network key
#define API_KEY "key"           // your Google API key
#define CHANNEL_ID "UC3ivOTE5EgpmF2DHLBmWIWg" // part of the channel url
//------- ----------------------------

uint8_t *framebuffer;
long subscribers,subscribersBefore = 0;
int cursor_x = 350;
int cursor_y = 310;

void setup()
{
   Serial.begin(115200);
    epd_init();
    epd_poweron();
    epd_clear();
    
   framebuffer = (uint8_t *)heap_caps_malloc(EPD_WIDTH * EPD_HEIGHT / 2, MALLOC_CAP_SPIRAM);
   memset(framebuffer, 0xFF, EPD_WIDTH * EPD_HEIGHT / 2);
   printBackground();
   epd_poweroff();

    // Connect to the WiFi network
  Serial.print("\nConnecting to WiFi: ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    Serial.print(".");
    delay(500);
  }
  Serial.println("\nWiFi connected!");
}


void loop()
{
  int length;
  String subscribersString = String(getSubscribers());
  
  if(subscribers != subscribersBefore)
  {
    printBackground();
    length = subscribersString.length();
    Serial.println(subscribers);
    writeln((GFXfont *)&demo, (char *)subscribersString.c_str(), &cursor_x, &cursor_y, NULL);
    epd_poweroff();
    subscribersBefore = subscribers;
  }
  delay(60000);  
}

int getSubscribers(){
  
  WiFiClientSecure client;
  client.setInsecure();
  YoutubeApi api(API_KEY, client);
  
  if(api.getChannelStatistics(CHANNEL_ID)) { 
    subscribers =  api.channelStats.subscriberCount;
  }
  return subscribers;
}

void printBackground()
{
   Rect_t area = {
        .x = 0,
        .y = 0,
        .width = youtube_width,
        .height =  youtube_height
    };
    epd_poweron();
    epd_clear_area(area);
    epd_draw_image(area, (uint8_t *) youtube_data, BLACK_ON_WHITE);
}
